﻿Public Class frmHello

    Dim buttonSystemColor As Object

    Private Sub frmHello_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        '**********************************************************************************************
        '*** operation once, when programm ends finally
        '**********************************************************************************************

        On Error Resume Next

        '*** variable declaration

        Dim errCode1 As UInteger


        '*** do closing operation package

        'clear message text on RoboTXController
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetRoboTxMessage(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, "")

        'do all waiting jobs before closing
        System.Windows.Forms.Application.DoEvents()
        System.Threading.Thread.Sleep(500)

        'closing operation
        errCode1 = classFtMscLib.FtLibDeclarations.ftxStopTransferArea(glFtHdl)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxCloseDevice(glFtHdl)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxCloseLib()

    End Sub

    Private Sub frmHello_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        '**********************************************************************************************
        '*** operation once, when programm starts the first time
        '**********************************************************************************************

        On Error Resume Next

        '*** variable declaration

        Dim n As Integer


        '*** do form loading operation package

        'prepare main operation button
        buttonSystemColor = Me.btnMainOperation.BackColor
        Me.btnMainOperation.BackColor = Color.Red

        'feed com channel combo box
        ListComChannels()
        n = 0
feedLoop:
        If glComChannels(n) <> "EOF" Then
            Me.cboComConnections.Items.Add(glComChannels(n))
            n = n + 1
            GoTo feedLoop
        End If

        'set applcation window title
        Me.Text = Application.ProductName & "   version " & Application.ProductVersion & "   for fischertechnik Robo TX Controller   " & Application.CompanyName

    End Sub

    Private Sub btnMainOperation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMainOperation.Click

        '**********************************************************************************************
        '*** main operation of serial function chains, on or off
        '**********************************************************************************************

        On Error Resume Next

        '*** variable declaration

        Dim errCode1 As UInteger


        '*** check selected mode

        If Me.btnMainOperation.Text = "process stopped" Then
            '*** serial function chains active
            'change button appearance
            Me.btnMainOperation.Text = "process running"
            Me.btnMainOperation.BackColor = Color.Green
            Me.tmrFlash.Enabled = True
            'inactivate button for com channel disconnect
            Me.btnComConnect.Enabled = False
            'write message to operation log
            OperationLogAddItem("")
            OperationLogAddItem("*** manual operation mode changed to 'process running'")
            'define working cycle interval
            Me.tmrWorkingCycle001.Interval = 200 'do it every ...ms
            Me.tmrWorkingCycle002.Interval = 200 'do it every ...ms
            Me.tmrWorkingCycle003.Interval = 200 'do it every ...ms
            System.Windows.Forms.Application.DoEvents()
            'define a new working cycle session
            glWC001FirstLoop = True
            glWC002FirstLoop = True
            glWC003FirstLoop = True
            'activate working cycle process
            Me.tmrWorkingCycle001.Enabled = True    'activate WorkingCycle 1
            Me.tmrWorkingCycle002.Enabled = True    'activate WorkingCycle 2
            Me.tmrWorkingCycle003.Enabled = False   'WorkingCycle 3 is not used
        Else
            '*** serial function chains stopped
            'deactivate working cycle process
            Me.tmrWorkingCycle001.Enabled = False   'stop WorkingCycle 1
            Me.tmrWorkingCycle002.Enabled = False   'stop WorkingCycle 2
            Me.tmrWorkingCycle003.Enabled = False   'stop WorkingCycle 3
            'stop motor
            glMotorSpeedLeft = 0
            glMotorSpeedRight = 0
            errCode1 = classFtMscLib.FtLibDeclarations.ftxSetOutMotorValues(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_M1, glMotorSpeedLeft, glMotorSpeedRight, classFtMscLib.FtLibConst.ROBOTXC_MODE_BRAKE)
            System.Windows.Forms.Application.DoEvents()
            'change button appearance
            Me.btnMainOperation.Text = "process stopped"
            Me.btnMainOperation.BackColor = Color.Red
            Me.tmrFlash.Enabled = False
            'inactivate button for com channel disconnect
            Me.btnComConnect.Enabled = True
            'write message to operation log
            OperationLogAddItem("")
            OperationLogAddItem("*** manual operation mode changed to 'process stopped'")
        End If

    End Sub

    Public Sub OperationLogAddItem(ByVal NewItem)

        '**********************************************************************************************
        '*** add one item to operation log list box
        '**********************************************************************************************

        'On Error Resume Next

        '*** variable declaration

        Dim linesCount As Integer


        'adds a new item to operation log control
        Me.lstbOperationLog.Items.Add(NewItem)

        'scroll to show always the last item
        linesCount = Me.lstbOperationLog.Items.Count - 1
        Me.lstbOperationLog.SetSelected(linesCount, True)
        Me.lstbOperationLog.SetSelected(linesCount, False)

    End Sub

    Private Sub chkShowOperationLog_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkShowOperationLog.CheckedChanged

        '**********************************************************************************************
        '*** show or hide operation log window
        '**********************************************************************************************

        On Error Resume Next

        If Me.chkShowOperationLog.Checked = True Then
            Me.Height = 693
            Me.Controls.Item("lstbOperationLog").Top = 470
            Me.lstbOperationLog.Visible = True
        Else
            Me.lstbOperationLog.Visible = False
            Me.Controls.Item("lstbOperationLog").Top = 52
            Me.Height = 493
        End If

    End Sub

    Private Sub tmrWorkingCycle001_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrWorkingCycle001.Tick

        '**********************************************************************************************
        '*** serial function chain operation of separate parallel working cycle 1
        '**********************************************************************************************

        On Error Resume Next

        WorkingCycle001()

    End Sub

    Private Sub tmrWorkingCycle002_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrWorkingCycle002.Tick

        '**********************************************************************************************
        '*** serial function chain operation of separate parallel working cycle 2
        '**********************************************************************************************

        On Error Resume Next

        WorkingCycle002()


    End Sub

    Private Sub tmrWorkingCycle003_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrWorkingCycle003.Tick

        '**********************************************************************************************
        '*** serial function chain operation of separate parallel working cycle 3
        '**********************************************************************************************

        On Error Resume Next

        WorkingCycle003()

    End Sub

    Private Sub tmrFlash_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrFlash.Tick

        '**********************************************************************************************
        '*** flash effect to indicate serial function chains are running
        '**********************************************************************************************

        On Error Resume Next

        If Me.btnMainOperation.BackColor = Color.Green Then
            Me.btnMainOperation.BackColor = buttonSystemColor
        Else
            Me.btnMainOperation.BackColor = Color.Green
        End If

    End Sub

    Private Sub btnComConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnComConnect.Click

        '**********************************************************************************************
        '*** connect via a chosen com port to a RoboTXController
        '**********************************************************************************************

        On Error Resume Next

        If Me.btnComConnect.Text = "connect" Then
            glThreadComConOK = False
            DoComConnection(Me.cboComConnections.SelectedItem)
            If glThreadComConOK = True Then
                Me.btnComConnect.Text = "disconnect"
                RoboTXControllerInfo()
                Me.cboComConnections.Enabled = False
                Me.btnMainOperation.Enabled = True
            Else
                MsgBox("Connection to " & glComSelectionMod & " failed. " & ControlChars.Cr & ControlChars.Cr & "Check your hardware setup or select an other com channel.", MsgBoxStyle.Critical, Application.ProductName & " - connection error")
            End If
        Else
            Me.btnComConnect.Text = "connect"
            DoComDisonnection()
            Me.cboComConnections.Enabled = True
            Me.btnMainOperation.Enabled = False
        End If

    End Sub

    Private Sub cboComConnections_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboComConnections.SelectedIndexChanged

        '**********************************************************************************************
        '*** a com channel selection was made
        '**********************************************************************************************

        On Error Resume Next

        Dim comItem As String

        comItem = Me.cboComConnections.SelectedItem

        If String.IsNullOrEmpty(comItem) = True Then
            Me.btnComConnect.Enabled = False
        Else
            If Strings.UCase(Strings.Left(comItem, 3)) = "COM" And Char.IsNumber(comItem, 3) = True Then
                Me.btnComConnect.Enabled = True
            Else
                Me.btnComConnect.Enabled = False
            End If
        End If

    End Sub

    Private Sub cboComConnections_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cboComConnections.TextChanged

        '**********************************************************************************************
        '*** a com channel text change was made, this is not allowed
        '**********************************************************************************************

        On Error Resume Next

        Me.btnComConnect.Enabled = False

    End Sub


    Private Sub btnInfo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInfo.Click

        '**********************************************************************************************
        '*** program info box
        '**********************************************************************************************

        '*** variable declaration
        Dim txtMsg As Object

        txtMsg = Application.ProductName & ", vers. " & Application.ProductVersion
        txtMsg = txtMsg & ControlChars.Cr & ControlChars.Cr
        txtMsg = txtMsg & Application.CompanyName & ", 2014" & ControlChars.Cr
        txtMsg = txtMsg & "for fischertechnik Robo TX Controller" & ControlChars.Cr & ControlChars.Cr
        txtMsg = txtMsg & "Program demonstrates how to use VisualBasic 2010 to control Fischertechnik" & ControlChars.Cr
        txtMsg = txtMsg & "models as an altertative to other developement invironments." & ControlChars.Cr & ControlChars.Cr
        txtMsg = txtMsg & "You can feel free to copy or distribute the project, but you must pay attention " & ControlChars.Cr
        txtMsg = txtMsg & "to the rights of microsoft, fischertechnik and others." & ControlChars.Cr & ControlChars.Cr
        txtMsg = txtMsg & "No guarantee, all on your own risk." & ControlChars.Cr & ControlChars.Cr
        txtMsg = txtMsg & "To publish your results would be appreciated by the community, e.g. under www.ftcommunity.de" & ControlChars.Cr & ControlChars.Cr
        txtMsg = txtMsg & "Special thanks to Carel van Leeuwen for basic information and support. Watch his pages:" & ControlChars.Cr
        txtMsg = txtMsg & "http://nl.linkedin.com/pub/carel-van-leeuwen/11/ba0/504" & ControlChars.Cr
        txtMsg = txtMsg & "http://web.inter.nl.net/users/Ussel-IntDev/"

        MsgBox(txtMsg, MsgBoxStyle.Information, Application.ProductName & " - version info")

    End Sub
End Class
