﻿Module modMain

    Sub RawDataEncoding()

        '**********************************************************************************************
        '*** raw data encoding
        '**********************************************************************************************

        'Debug.Print("raw data encoding... " & Now())


        '*** variable declaration

        Dim n As Integer                        'counter variable for-next-loop
        Dim lastRawResultType As Integer        '0 or 1, active number looking for
        Dim blockNumber As Integer              'block number with equal numbers 0 or 1
        Dim elementNumber As Integer            'for counting equal elements per block
        Dim resultNumeric As String
        Dim elementCount As Integer
        Dim resultEnd As String


        '*** do processing of encoding

        'send a message to operation log    
        frmHello.OperationLogAddItem("")
        frmHello.OperationLogAddItem("SFC:    doing raw data encoding, this stops all oher operations")

        'analyse equal elements per block
        lastRawResultType = glRawReading(1)
        blockNumber = 1
        elementNumber = 1
        For n = 2 To glRawReading(0)
            If lastRawResultType = glRawReading(n) Then
                elementNumber = elementNumber + 1
            Else
                glRawSummary(blockNumber) = elementNumber
                'Debug.Print(glRawSummary(blockNumber))
                lastRawResultType = glRawReading(n)
                elementNumber = 1
                blockNumber = blockNumber + 1
            End If
        Next n
        glRawSummary(blockNumber) = elementNumber
        glRawSummary(0) = blockNumber
        'Debug.Print(glRawSummary(blockNumber))

        elementCount = glRawSummary(0)

        'encoding trial 1 without correction factor
        resultEnd = ""
        For n = 1 To elementCount - 9
            resultNumeric = resultEncoder(calcResultCode(n, 1))
            'Debug.Print(resultNumeric)
            If resultNumeric <> "error" Then
                resultEnd = resultEnd & resultNumeric
            End If
        Next n
            If Len(resultEnd) = 1 Then GoTo exitFunction

        corrFactor = 0.01

        For m = 1 To 100

            'encoding trial 2 with correction factor lower than 1
            resultEnd = ""
            For n = 1 To elementCount - 9
                resultNumeric = resultEncoder(calcResultCode(n, 1 - m * corrFactor))
                'Debug.Print(resultNumeric)
                If resultNumeric <> "error" Then
                    resultEnd = resultEnd & resultNumeric
                End If
            Next n
            If Len(resultEnd) = 1 Then GoTo exitFunction

            'encoding trial 3 with correction factor lower than 1
            resultEnd = ""
            For n = 1 To elementCount - 9
                resultNumeric = resultEncoder(calcResultCode(n, 1 + m * corrFactor))
                'Debug.Print(resultNumeric)
                If resultNumeric <> "error" Then
                    resultEnd = resultEnd & resultNumeric
                End If
            Next n
            If Len(resultEnd) = 1 Then GoTo exitFunction

        Next m

        resultEnd = "error"

exitFunction:

        'write result to main window control
        If resultEnd = "error" Then
            frmHello.lblResultNumber.Visible = False
            frmHello.lblError.Visible = True
        Else
            frmHello.lblError.Visible = False
            frmHello.lblResultNumber.Text = resultEnd
            frmHello.lblResultNumber.Visible = True
        End If

        'send a message to operation log    
        frmHello.OperationLogAddItem("          scan result=" & resultEnd)

        'send a message to operation log    
        frmHello.OperationLogAddItem("")
        frmHello.OperationLogAddItem("SFC:    raw data encoding ready, waiting for new commands")

    End Sub

    Function resultEncoder(ByVal InputCode As String) As String

        '**********************************************************************************************
        '*** encoding the result sting, if possible
        '**********************************************************************************************

        resultEncoder = "error"

        If InputCode = "111221211" Or InputCode = "112122111" Then
            resultEncoder = "0"
        End If
        If InputCode = "211211112" Or InputCode = "211112112" Then
            resultEncoder = "1"
        End If
        If InputCode = "112211112" Or InputCode = "211112211" Then
            resultEncoder = "2"
        End If
        If InputCode = "212211111" Or InputCode = "111112212" Then
            resultEncoder = "3"
        End If
        If InputCode = "111221112" Or InputCode = "211122111" Then
            resultEncoder = "4"
        End If
        If InputCode = "211221111" Or InputCode = "111122112" Then
            resultEncoder = "5"
        End If
        If InputCode = "112221111" Or InputCode = "111122211" Then
            resultEncoder = "6"
        End If
        If InputCode = "111211212" Or InputCode = "212112111" Then
            resultEncoder = "7"
        End If
        If InputCode = "211211211" Or InputCode = "112112112" Then
            resultEncoder = "8"
        End If
        If InputCode = "112211211" Or InputCode = "112112211" Then
            resultEncoder = "9"
        End If

    End Function


    Function calcResultCode(ByVal StartSign As Integer, ByVal optFactor As Decimal) As String

        '**********************************************************************************************
        '*** generating the result string
        '**********************************************************************************************


        '*** variable declaration

        Dim sumTotal As Decimal                 'sum of all relevant blocks
        Dim resultCode As String                'result of bar code reading


        'calculate sum of all relevant numbers
        sumTotal = 0
        For n = StartSign To StartSign + 8
            sumTotal = sumTotal + glRawSummary(n)
        Next n

        'calculate modified elements per block
        resultCode = ""
        For n = StartSign To StartSign + 8
            resultCode = resultCode & Right(Str(System.Math.Round(glRawSummary(n) / (sumTotal / 12) * optFactor)), 1)
        Next n

        calcResultCode = resultCode

    End Function

End Module
