﻿
Module modMainWC001

    Sub WorkingCycle001()

        '**********************************************************************************************
        '*** serial function chain working cycle 1
        '**********************************************************************************************

        'Debug.Print("WC001 main runnng... " & Now())


        '*** variable declaration

        Dim errCode1 As UInteger        'error code
        Dim valRefI3 As Short           'status input pis I3
        Dim valRefI4 As Short           'status input pis I4
        Dim valRefI8 As Short           'status input pis I8
        Dim overrunRef As Boolean       'not used


        '*** check if init of working cycle 1 has to be done first

        If glWC001FirstLoop = True Then
            glWC001FirstLoop = False
            WorkingCycle001Init()
        End If


        '*** read relevant input status, result is stored under valRefIx, overrunRef not used

        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I3, valRefI3, overrunRef)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I4, valRefI4, overrunRef)
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I8, valRefI8, overrunRef)
        System.Windows.Forms.Application.DoEvents()


        '*** do function chain logic commands

        'status (1.1): carrier is at right end position AND carrier is running right
        'operation: stop carrier
        If valRefI3 = 1 And glMotorSpeedRight = 512 Then
            frmHello.OperationLogAddItem("")
            frmHello.OperationLogAddItem("SFC:    doing status 1.1 operation (carrier is at right end position AND carrier is running right; operation: stop carrier)")
            glMotorSpeedLeft = 0
            glMotorSpeedRight = 0
            errCode1 = classFtMscLib.FtLibDeclarations.ftxSetOutMotorValues(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_M1, glMotorSpeedLeft, glMotorSpeedRight, classFtMscLib.FtLibConst.ROBOTXC_MODE_BRAKE)
            System.Windows.Forms.Application.DoEvents()

            'load picture on main window
            frmHello.picModel.Image = My.Resources.Resources.pic01Right
            System.Windows.Forms.Application.DoEvents()

            'when carrier has stopped, start raw data encoding
            If glRawDataReady = True Then
                glRawDataReady = False
                RawDataEncoding()
            End If
        End If

        'status (1.2): carrier is at left end position AND carrier is running left
        'operation: stop carrier
        If valRefI4 = 1 And glMotorSpeedLeft = 512 Then
            frmHello.OperationLogAddItem("")
            frmHello.OperationLogAddItem("SFC:    doing status 1.2 operation (carrier is at left end position AND carrier is running left; operation: stop carrier)")
            glMotorSpeedLeft = 0
            glMotorSpeedRight = 0
            errCode1 = classFtMscLib.FtLibDeclarations.ftxSetOutMotorValues(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_M1, glMotorSpeedLeft, glMotorSpeedRight, classFtMscLib.FtLibConst.ROBOTXC_MODE_BRAKE)
            System.Windows.Forms.Application.DoEvents()

            'load picture on main window
            frmHello.picModel.Image = My.Resources.Resources.pic05Left
            System.Windows.Forms.Application.DoEvents()

            'when carrier has stopped, start raw data encoding
            If glRawDataReady = True Then
                glRawDataReady = False
                RawDataEncoding()
            End If
        End If

        'status (1.3): carrier start button is pressed 
        'operation: start carrier left or right
        If valRefI8 = 1 Then
            frmHello.OperationLogAddItem("")
            frmHello.OperationLogAddItem("SFC:    doing status 1.3 operation (carrier start button is pressed; operation: start carrier left or right)")
            If glMotorSpeedLeft = 0 And glMotorSpeedRight = 0 And valRefI3 = 0 And valRefI4 = 0 Then
                'status (1.3a): carrier stands still and is not at right or left end point 
                'operation: start carrier left 
                frmHello.OperationLogAddItem("          doing status 1.3a operation (carrier stands still and is not at right or left end point; start carrier left)")
                glMotorSpeedLeft = 512
                glMotorSpeedRight = 0
                errCode1 = classFtMscLib.FtLibDeclarations.ftxSetOutMotorValues(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_M1, glMotorSpeedLeft, glMotorSpeedRight, classFtMscLib.FtLibConst.ROBOTXC_MODE_RUN)
                frmHello.lblResultNumber.Visible = False
                frmHello.lblError.Visible = False
                System.Windows.Forms.Application.DoEvents()
            End If
            If valRefI3 = 1 Then
                'status (1.3b): carrier is at right end point 
                'operation: start carrier left 
                frmHello.OperationLogAddItem("          doing status 1.3b operation (carrier is at right end point; start carrier left)")
                glMotorSpeedLeft = 512
                glMotorSpeedRight = 0
                errCode1 = classFtMscLib.FtLibDeclarations.ftxSetOutMotorValues(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_M1, glMotorSpeedLeft, glMotorSpeedRight, classFtMscLib.FtLibConst.ROBOTXC_MODE_RUN)
                frmHello.lblResultNumber.Visible = False
                frmHello.lblError.Visible = False
                System.Windows.Forms.Application.DoEvents()
                'load picture on main window
                frmHello.picModel.Image = My.Resources.Resources.pic02RightMoving
                System.Windows.Forms.Application.DoEvents()
            End If
            If valRefI4 = 1 Then
                'status (1.3c): carrier is at left end point 
                'operation: start carrier right 
                frmHello.OperationLogAddItem("          doing status 1.3c operation (carrier is at left end point; start carrier right)")
                glMotorSpeedLeft = 0
                glMotorSpeedRight = 512
                errCode1 = classFtMscLib.FtLibDeclarations.ftxSetOutMotorValues(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_M1, glMotorSpeedLeft, glMotorSpeedRight, classFtMscLib.FtLibConst.ROBOTXC_MODE_RUN)
                frmHello.lblResultNumber.Visible = False
                frmHello.lblError.Visible = False
                System.Windows.Forms.Application.DoEvents()
                'load picture on main window
                frmHello.picModel.Image = My.Resources.Resources.pic04LeftMoving
                System.Windows.Forms.Application.DoEvents()
            End If
        End If

    End Sub

    Sub WorkingCycle001Init()

        '**********************************************************************************************
        '*** serial function chain working cycle 1, init when running the first loop
        '**********************************************************************************************

        '*** variable declaration

        Dim errCode1 As UInteger


        '*** define input pins of RoboTXController

        'send a message to operation log    
        frmHello.OperationLogAddItem("")
        frmHello.OperationLogAddItem("SFC:    doing WC001Init operation")

        'define input pin I3 as digital input 5kOhm
        'I3 = carrier at right end position
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetUniConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I3, classFtMscLib.FtLibConst.ROBOTXC_MODE_RESISTANCE, classFtMscLib.FtLibConst.ROBOTXC_MODE_DIGITAL)

        'define input pin I4 as digital input 5kOhm
        'I4 = carrier at left end position
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetUniConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I4, classFtMscLib.FtLibConst.ROBOTXC_MODE_RESISTANCE, classFtMscLib.FtLibConst.ROBOTXC_MODE_DIGITAL)

        'define input pin I8 as digital input 5kOhm
        'I8 = start carrier operation
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetUniConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I8, classFtMscLib.FtLibConst.ROBOTXC_MODE_RESISTANCE, classFtMscLib.FtLibConst.ROBOTXC_MODE_DIGITAL)


        '*** define output pins of RoboTXController

        'define output pins M1 (=O1 and O2) as motor connectors
        'M1 = main drive for bar code carrier
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetOutMotorConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_M1, classFtMscLib.FtLibConst.ROBOTXC_MODE_MOTOR)

    End Sub

End Module
