﻿
Module modMainWC002

    Sub WorkingCycle002()

        '**********************************************************************************************
        '*** serial function chain working cycle 2
        '**********************************************************************************************

        'Debug.Print("WC002 main runnng... " & Now())


        '*** variable declaration

        Dim errCode1 As UInteger        'error code
        Dim valRefI1 As Short           'status input pis I3
        Dim overrunRef As Boolean       'not used
        Dim timeStampEnd As Date        'end time for reading bar code sequence
        Dim sequenceCount As Long       'counter during reading process


        '*** check if init of working cycle 2 has to be done first

        If glWC002FirstLoop = True Then
            glWC002FirstLoop = False
            WorkingCycle002Init()
        End If


        '*** read b/w sensor, result is stored under valRefIx, overrunRef not used
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I1, valRefI1, overrunRef)
        If valRefI1 = 0 Then Exit Sub

        'status (2.1): sensor detected white 
        'operation: start reading sequence 

        'write message to operation log
        frmHello.OperationLogAddItem("")
        frmHello.OperationLogAddItem("SFC:    doing status 2.1 operation (sensor detected white; operation: start reading sequence)")

        'load picture on main window
        frmHello.picModel.Image = My.Resources.Resources.pic03Reading
        System.Windows.Forms.Application.DoEvents()

        'end time stamp of reading bar code sequence (sequence time = 4 seconds)
        timeStampEnd = Now().AddSeconds(4)
        frmHello.OperationLogAddItem("          " & Now() & " to " & timeStampEnd)
        sequenceCount = 1

        'bar code reading sequence, for max. reading speed no other job will be done
barCodeReadingSequence:
        errCode1 = classFtMscLib.FtLibDeclarations.ftxGetInIOValue(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I1, valRefI1, overrunRef)
        glRawReading(sequenceCount) = valRefI1
        sequenceCount = sequenceCount + 1
        System.Threading.Thread.Sleep(1)
        If timeStampEnd > Now() Then GoTo barCodeReadingSequence
        glRawReading(0) = sequenceCount
        frmHello.OperationLogAddItem("          " & sequenceCount & " raw data items collected")
        glRawDataReady = True

    End Sub

    Sub WorkingCycle002Init()

        '**********************************************************************************************
        '*** serial function chain working cycle 2, init when running the first loop
        '**********************************************************************************************

        '*** variable declaration

        Dim errCode1 As UInteger


        '*** define input pins of RoboTXController

        'send a message to operation log    
        frmHello.OperationLogAddItem("")
        frmHello.OperationLogAddItem("SFC:    doing WC002Init operation")

        'define input pin I1 as digital input 10V
        'I1 = black/white sensor
        errCode1 = classFtMscLib.FtLibDeclarations.ftxSetUniConfig(glFtHdl, classFtMscLib.FtLibConst.ROBOTXC_MASTER, classFtMscLib.FtLibConst.ROBOTXC_I1, classFtMscLib.FtLibConst.ROBOTXC_MODE_VOLTAGE, classFtMscLib.FtLibConst.ROBOTXC_MODE_DIGITAL)

    End Sub

End Module
